package systems
{
	import com.tomseysdavies.ember.base.Entity;
	import com.tomseysdavies.ember.base.EntityManager;
	import com.tomseysdavies.ember.base.Family;
	import com.tomseysdavies.ember.core.IEntity;
	import com.tomseysdavies.ember.core.IFamily;
	import com.tomseysdavies.ember.core.ISystem;
	
	import components.GraphicsComponent;
	import components.PositionComponent;
	
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.DisplayObjectContainer;
	import flash.display.Sprite;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	
	public class RenderingSystem implements ISystem
	{
		[Inject] public var contextView:DisplayObjectContainer;
		[Inject] public var entityManager:EntityManager;		
		private var _family:IFamily;
		private var _viewPort:Bitmap;
		
		public function onRegister():void{
			_family = entityManager.getEntityFamily(PositionComponent,GraphicsComponent);
			_family.iterator.add(renderEntity);
			
			_viewPort = new Bitmap()
			_viewPort.bitmapData = new BitmapData(400,400);
			contextView.addChild(_viewPort);
			
			render()
		}
		
		private function render():void{
			_viewPort.bitmapData.fillRect(new Rectangle(0,0,400,400),0xFFFFCC);
			_family.startIterator();
		}

		private function renderEntity(position:PositionComponent,graphics:GraphicsComponent):void{
			_viewPort.bitmapData.copyPixels(graphics.asset.bitmapData,graphics.asset.bitmapData.rect,new Point(position.x,position.y),null,null,true);
		}
		
		public function destroy():void
		{
			_family.iterator.remove(renderEntity);
			_viewPort.bitmapData.dispose();
		}
	}
}